#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <tuple>
using namespace std;

int n, t;
long long c, k;
vector<tuple<int, long long, int>> v;

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> c;
    for (int i = 0; i < n; i++)
    {
        cin >> t >> k;
        v.push_back(make_tuple(t, k, i));
    }

    sort(v.rbegin(), v.rend());

    set<pair<long long, int>> q;
    vector<int> ans;
    for (int i = 0; i < n; i++)
    {
        q.insert(make_pair(get<1>(v[i]), get<2>(v[i])));
        long long cur = get<0>(v[i]) - (i + 1 == n ? 0 : get<0>(v[i + 1]));
        cur *= c;
        while (cur > 0 and !q.empty())
        {
            if (q.begin()->first <= cur)
            {
                cur -= q.begin()->first;
                ans.push_back(q.begin()->second);
                q.erase(q.begin());
            }
            else
            {
                pair<long long, int> t = *q.begin();
                q.erase(t);
                q.insert(make_pair(t.first - cur, t.second));
                cur = 0;
            }
        }
    }

    cout << ans.size() << endl;
    for (int p : ans)
    {
        cout << p + 1 << ' ';
    }
    cout << endl;
    return 0;
}
